package com.ibeetl.admin.core.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 描述: 用来标注词典字段
 * 
 *
 * @author : lijiazhi
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface Dict {

    /**
     * 类型
     *
     * @return
     */
    String type() default "";

    /**
     * 默认值
     *
     * @return
     */
    String defaultDisplay() default "";

    /**
     * 字典文本的后缀
     *
     * @return
     */
    String suffix() default "Text";
}
