package com.ibeetl.admin.core.conf;

import com.ibeetl.admin.core.conf.PasswordConfig.PasswordEncryptService;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * 描述: 密码工具，系统默认采用明文
 *
 * @author : xiandafu
 */
@Configuration
@ConditionalOnMissingBean(PasswordEncryptService.class)
public class PasswordConfig {

	
	public interface PasswordEncryptService{
		String password(String pwd);
	}
	
	
	public static class DefaultEncryptBean implements PasswordEncryptService {

		@Override
		public String password(String pwd) {
			// 采用明文，系统应该提供自己的EncryptBean实现以代替默认
			return pwd;
		}

	}
	
	@Bean
	public PasswordEncryptService passwordEncryptBean(){
		return new DefaultEncryptBean();
	}

}
